// Script layout for BVQX 2.2 generated by ScriptFromUI Plugin
// NOTE: Instead of "dlg.findChild()" we use "bvqx.FindChild()" since "findChild" is currently not working with script extensions

var bvqx = BrainVoyager; // use short symbol to access BrainVoyager QX API

var scriptObj = new Object;
scriptObj.scriptNameForUser = "TalMNICoord2VOI"; // NOT relevant for Plugin GUI script - specify name by which script will be shown to user (e.g. in menu)
scriptObj.dialogFileName    = "TalMNICoord2VOI.ui"; // specify name of file that will be used by BVQX to create your UI
scriptObj.dialogAccessName  = "PluginDialog"; // specify the name you want to use for accessing your UI

// Initializing global variables for GUI elements
// MNI or Tal
var MNIorTal;
// push buttons
var btn_ReadText, btn_SaveText, btn_CleanUp, btn_Cancel, btn_Start;
// radio buttons
var rbtn_FromText;
// check boxes
var chbox_Load;
// spin boxes
var spbox_X, spbox_Y, spbox_Z, spbox_R, spbox_G, spbox_B;
// list
var listVOIinfoFrom;
// dialog itself
var dlg;


scriptObj.initDlg = function()
{
   dlg = this.PluginDialog; // less to write
   // find push buttons
   MNIorTal = bvqx.FindChild("mniradioButton");
   btn_Cancel = bvqx.FindChild("btn_Cancel");
   btn_Start = bvqx.FindChild("btn_Start");
   btn_ReadText = bvqx.FindChild("btn_ReadText");
   btn_SaveText = bvqx.FindChild("btn_SaveText");
   btn_CleanUp = bvqx.FindChild("btn_CleanUp");
   // find list
   listVOIinfoFrom = bvqx.FindChild("listVOIinfoFrom");
   // find check boxes
   chbox_Load = bvqx.FindChild("chbox_Load");
   // find spin boxes
   spbox_X = bvqx.FindChild("spbox_X");
   spbox_Y = bvqx.FindChild("spbox_Y");
   spbox_Z = bvqx.FindChild("spbox_Z");
   spbox_radius = bvqx.FindChild("spbox_radius");
   spbox_R = bvqx.FindChild("spbox_R");
   spbox_G = bvqx.FindChild("spbox_G");
   spbox_B = bvqx.FindChild("spbox_B");
   // find Line edits
   voiname = bvqx.FindChild("voiname");
   filename = bvqx.FindChild("filename");
   textVOIs = bvqx.FindChild("textVOIs");
   
   // connec UI elements to script functions - you need to know the names of your elements (check your definition)
   btn_Cancel.clicked.connect(this, this.clicked_btn_Cancel);
   btn_Start.clicked.connect(this, this.clicked_btn_Start);
   btn_ReadText.clicked.connect(this, this.clicked_btn_ReadText);
   btn_SaveText.clicked.connect(this, this.clicked_btn_SaveText);
   btn_CleanUp.clicked.connect(this, this.clicked_btn_CleanUp);
}


scriptObj.clicked_btn_Cancel = function()
{
   bvqx.PrintToLog("Script>  Dialog's Cancel button clicked");
   dlg.close();
}


scriptObj.clicked_btn_Start = function()
{
   bvqx.PrintToLog("Script>  Dialog's Start button clicked");
   
   bvqx.SetPluginStringParameter("Command", "Start");
   bvqx.SetPluginIntParameter("listVOIinfoFrom", listVOIinfoFrom.currentRow); 
   bvqx.SetPluginStringParameter("VOItext", textVOIs.plainText);
   
   //Examples from Dialog to Plugin
   bvqx.SetPluginIntParameter("MNIorTal", MNIorTal.checked); 
   bvqx.SetPluginFloatParameter("tX", spbox_X.value);
   bvqx.SetPluginFloatParameter("tY", spbox_Y.value);
   bvqx.SetPluginFloatParameter("tZ", spbox_Z.value);
   bvqx.SetPluginFloatParameter("Radius", spbox_radius.value);
   bvqx.SetPluginStringParameter("Name_of_VOI", voiname.text);
   bvqx.SetPluginIntParameter("cR", spbox_R.value);
   bvqx.SetPluginIntParameter("cG", spbox_G.value);
   bvqx.SetPluginIntParameter("cB", spbox_B.value);
   bvqx.SetPluginStringParameter("FileName", filename.text);
   bvqx.SetPluginIntParameter("LoadInBV", chbox_Load.checked);
   
   dlg.close();
   
   bvqx.ExecutePlugin();

}

scriptObj.clicked_btn_ReadText = function()
{
   bvqx.PrintToLog("Script>  Dialog's ReadTextFile button clicked");

   bvqx.SetPluginStringParameter("Command", "ReadTextFile");

   //bvqx.SetPluginStringParameter("SomeText", dlg.textbrowser.plainText);
   //bvqx.SetPluginIntParameter("SomeInt", CheckBoxName.checked or RadioButtonName.checked);
   //bvqx.SetPluginFloatParameter("SomeFloat", SpinBoxName.value);

   bvqx.ExecutePlugin();

   //Examples from Plugin to Dialog
   var newText = bvqx.GetPluginStringParameter("AllText");
   textVOIs.plainText = newText;
   //var newInt = bvqx.GetPluginIntParameter("SomeInt");
   //var newFloat = bvqx.GetPluginFloatParameter("SomeFloat");
}


scriptObj.clicked_btn_SaveText = function()
{
   bvqx.PrintToLog("Script>  Dialog's SaveTextFile button clicked");

   bvqx.SetPluginStringParameter("Command", "SaveTextFile");
   bvqx.SetPluginStringParameter("VOItext", textVOIs.plainText);
   
   bvqx.ExecutePlugin();
}

scriptObj.clicked_btn_CleanUp = function()
{
   bvqx.PrintToLog("Script>  Dialog's CleanUpText button clicked");

   bvqx.SetPluginStringParameter("Command", "CleanUpText");
   bvqx.SetPluginStringParameter("VOItext", textVOIs.plainText);

   bvqx.ExecutePlugin();
   
   var newText = bvqx.GetPluginStringParameter("VOItext");
   textVOIs.plainText = newText;
}

returnScriptObj = function()
{
   return scriptObj; // it is important to return script object containing properties and functions to be called from BrainVoyager QX
}
returnScriptObj();
